## nheko 0.11.3+~0.9.2+~1.0.0+~0.3.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

option(APPVEYOR_BUILD "Build on appveyor" OFF)
option(CI_BUILD "Set when building in CI. Enables -Werror where possible" OFF)
option(ASAN "Compile with address sanitizers" OFF)
option(QML_DEBUGGING "Enable qml debugging" OFF)
option(COMPILE_QML "Compile Qml. It will make Nheko faster, but you will need to recompile it, when you update Qt." OFF)
if(UNIX AND NOT APPLE)
	option(MAN "Build man page" ON)
else()
	option(MAN "Build man page" OFF)
endif()
option(FLATPAK "Set this only if Nheko is built as a flatpak" OFF)
option(JSON_ImplicitConversions "Disable implicit conversions in nlohmann/json" ON)

set(
	CMAKE_TOOLCHAIN_FILE "${CMAKE_CURRENT_LIST_DIR}/toolchain.cmake"
	CACHE
	FILEPATH "Default toolchain"
	)
set(CMAKE_CXX_STANDARD 20 CACHE STRING "C++ standard")
set(CMAKE_CXX_STANDARD_REQUIRED ON CACHE BOOL "Require C++ standard to be supported")
set(CMAKE_POSITION_INDEPENDENT_CODE ON CACHE BOOL "compile as PIC by default")

option(HUNTER_ENABLED "Enable Hunter package manager" OFF)
include("cmake/HunterGate.cmake")
HunterGate(
    URL "https://github.com/cpp-pm/hunter/archive/v0.24.8.tar.gz"
    SHA1 "ca7838dded9a1811b04ffd56175f629e0af82d3d"
    LOCAL
)

macro(hunter_add_package_safe)
	set(pkg_temp_backup_libdir "$ENV{PKG_CONFIG_LIBDIR}")
	set(pkg_temp_backup_path "$ENV{PKG_CONFIG_PATH}")
	hunter_add_package(${ARGV})
	if("${pkg_temp_backup_path}" STREQUAL "")
		unset(ENV{PKG_CONFIG_PATH})
	else()
		set(ENV{PKG_CONFIG_PATH} "${pkg_temp_backup_path}")
	endif()
	if("${pkg_temp_backup_libdir}" STREQUAL "")
		unset(ENV{PKG_CONFIG_LIBDIR})
	else()
		set(ENV{PKG_CONFIG_LIBDIR} "${pkg_temp_backup_libdir}")
	endif()
	message("pkg_conf_path: '$ENV{PKG_CONFIG_PATH}', pkg_conf_libdir: '$ENV{PKG_CONFIG_LIBDIR}'")
endmacro()

option(USE_BUNDLED_SPDLOG "Use the bundled version of spdlog." ${HUNTER_ENABLED})
option(USE_BUNDLED_OLM "Use the bundled version of libolm." ${HUNTER_ENABLED})
option(USE_BUNDLED_GTEST "Use the bundled version of Google Test." ${HUNTER_ENABLED})
option(USE_BUNDLED_CMARK "Use the bundled version of cmark." ${HUNTER_ENABLED})
option(USE_BUNDLED_JSON "Use the bundled version of nlohmann json." ${HUNTER_ENABLED})
option(USE_BUNDLED_OPENSSL "Use the bundled version of OpenSSL." OFF)
option(USE_BUNDLED_MTXCLIENT "Use the bundled version of the Matrix Client library." ${HUNTER_ENABLED})
option(USE_BUNDLED_LMDB "Use the bundled version of lmdb." ${HUNTER_ENABLED})
option(USE_BUNDLED_LMDBXX "Use the bundled version of lmdb++." ${HUNTER_ENABLED})
option(USE_BUNDLED_QTKEYCHAIN "Use the bundled version of Qt5Keychain." ${HUNTER_ENABLED})
option(USE_BUNDLED_COEURL "Use a bundled version of the Curl wrapper"
	${HUNTER_ENABLED})
option(USE_BUNDLED_LIBEVENT "Use the bundled version of libevent." ${HUNTER_ENABLED})
option(USE_BUNDLED_LIBCURL "Use the bundled version of libcurl." ${HUNTER_ENABLED})
option(USE_BUNDLED_RE2 "Use the bundled version of re2." ${HUNTER_ENABLED})
option(USE_BUNDLED_CPPHTTPLIB "Use the bundled version of cpp-httplib." ON)
option(USE_BUNDLED_BLURHASH "Use the bundled version of blurhash." ON)

include(CMakeDependentOption)
set(VOIP_DEFAULT ON)
if (APPLE OR WIN32)
	set(VOIP_DEFAULT OFF)
endif()
option(VOIP "Whether to enable voip support. Disable this, if you don't have gstreamer." ${VOIP_DEFAULT})
cmake_dependent_option(SCREENSHARE_X11 "Whether to enable screenshare support on X11." ON "VOIP" OFF)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

if(${CMAKE_VERSION} VERSION_LESS "3.14.0")
	message("Adding FetchContent_MakeAvailable")
	# from cmakes sources
	macro(FetchContent_MakeAvailable)

		foreach(contentName IN ITEMS ${ARGV})
			string(TOLOWER ${contentName} contentNameLower)
			FetchContent_GetProperties(${contentName})
			if(NOT ${contentNameLower}_POPULATED)
				FetchContent_Populate(${contentName})

				# Only try to call add_subdirectory() if the populated content
				# can be treated that way. Protecting the call with the check
				# allows this function to be used for projects that just want
				# to ensure the content exists, such as to provide content at
				# a known location.
				if(EXISTS ${${contentNameLower}_SOURCE_DIR}/CMakeLists.txt)
					add_subdirectory(${${contentNameLower}_SOURCE_DIR}
						${${contentNameLower}_BINARY_DIR})
				endif()
			endif()
		endforeach()

	endmacro()
endif()

# Include Qt basic functions
include(QtCommon)

project(nheko LANGUAGES CXX C)

include(GNUInstallDirs)

set(CPACK_PACKAGE_VERSION_MAJOR "0")
set(CPACK_PACKAGE_VERSION_MINOR "11")
set(CPACK_PACKAGE_VERSION_PATCH "3")
set(PROJECT_VERSION_MAJOR ${CPACK_PACKAGE_VERSION_MAJOR})
set(PROJECT_VERSION_MINOR ${CPACK_PACKAGE_VERSION_MINOR})
set(PROJECT_VERSION_PATCH ${CPACK_PACKAGE_VERSION_PATCH})

# Set PROJECT_VERSION_PATCH & PROJECT_VERSION_TWEAK to 0 if not present
# Needed by add_project_meta.
fix_project_version()

# Set additional project information
set(COMPANY "Nheko")
set(COPYRIGHT "Copyright (c) 2023 Nheko Contributors")
set(IDENTIFIER "io.github.nheko-reborn.nheko")

add_project_meta(META_FILES_TO_INCLUDE)

if(NOT MSVC AND NOT APPLE)
	set(THREADS_PREFER_PTHREAD_FLAG ON)
	find_package(Threads REQUIRED)
endif()

if (BUILD_DOCS)
	find_package(Doxygen)

	if (DOXYGEN_FOUND)
		set(DOXYGEN_IN ${CMAKE_CURRENT_SOURCE_DIR}/cmake/Doxyfile.in)
		set(DOXYGEN_OUT ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)

		configure_file(${DOXYGEN_IN} ${DOXYGEN_OUT})

		add_custom_target(docs ALL
			COMMAND ${DOXYGEN_EXECUTABLE} ${DOXYGEN_OUT}
			WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
			COMMENT "Generating API documentation with Doxygen"
			VERBATIM )
	else (DOXYGEN_FOUND)
		message("Doxygen need to be installed to generate the doxygen documentation")
	endif (DOXYGEN_FOUND)
endif()

#
## coeurl
#
## Need to repeat all libevent deps?!?
if (USE_BUNDLED_LIBEVENT)
	hunter_add_package_safe(Libevent)
	find_package(Libevent CONFIG REQUIRED)
else()
	find_package(PkgConfig REQUIRED) 
	pkg_check_modules(libevent_core REQUIRED IMPORTED_TARGET libevent_core)
	if (WIN32)
		pkg_check_modules(libevent_windows REQUIRED IMPORTED_TARGET libevent_windows)
	else()
		pkg_check_modules(libevent_pthreads REQUIRED IMPORTED_TARGET
			libevent_pthreads)
	endif()
endif()

# curl
if (USE_BUNDLED_LIBCURL)
	hunter_add_package_safe(CURL)
	find_package(CURL CONFIG REQUIRED)
else()
	find_package(PkgConfig REQUIRED) 
	pkg_check_modules(libcurl REQUIRED IMPORTED_TARGET libcurl)
endif()

# spdlog
if(USE_BUNDLED_SPDLOG)
	hunter_add_package_safe(spdlog)
endif()
find_package(spdlog 1.0.0 CONFIG REQUIRED)

if(USE_BUNDLED_COEURL)
	include(FetchContent)
	FetchContent_Declare(
		coeurl
		GIT_REPOSITORY https://nheko.im/Nheko-Reborn/coeurl.git
		GIT_TAG        v0.3.0
		)
	FetchContent_MakeAvailable(coeurl)
	set(COEURL_TARGET_NAME coeurl::coeurl)
else()
	find_package(PkgConfig)
	pkg_check_modules(coeurl IMPORTED_TARGET coeurl>=0.3.0)
	if (TARGET PkgConfig::coeurl)
		set(COEURL_TARGET_NAME PkgConfig::coeurl)
	endif()
endif()

if(NOT TARGET PkgConfig::coeurl)
	find_package(coeurl 0.2.1 CONFIG)
	if (TARGET coeurl::coeurl)
		set(COEURL_TARGET_NAME coeurl::coeurl)
	endif()
endif()

if (NOT COEURL_TARGET_NAME)
	message(ERROR "Couldn't find coeurl")
endif()

if(USE_BUNDLED_RE2)
	hunter_add_package(re2)
	find_package(re2 CONFIG REQUIRED)
else()
	find_package(PkgConfig REQUIRED)
	pkg_check_modules(re2 REQUIRED IMPORTED_TARGET re2)
endif()


#
# LMDB
#
#include(LMDB)
if(USE_BUNDLED_LMDB)
	hunter_add_package_safe(lmdb)
	find_package(liblmdb CONFIG REQUIRED)

	target_include_directories(liblmdb::lmdb INTERFACE
		"${HUNTER_INSTALL_PREFIX}/include/lmdb")
else()
	find_package(LMDB REQUIRED)
endif()

#
# Discover Qt dependencies.
#
find_package(Qt5 5.15 COMPONENTS Core Widgets LinguistTools Concurrent Svg Multimedia Qml QuickControls2 QuickWidgets REQUIRED)
find_package(Qt5QuickCompiler)
find_package(Qt5DBus)

if (USE_BUNDLED_QTKEYCHAIN)
	include(FetchContent)
	FetchContent_Declare(
		qt5keychain
		GIT_REPOSITORY https://github.com/frankosterfeld/qtkeychain.git
		GIT_TAG        v0.13.1
		)
	if (BUILD_SHARED_LIBS)
		set(QTKEYCHAIN_STATIC OFF CACHE INTERNAL "")
	else()
		set(QTKEYCHAIN_STATIC ON CACHE INTERNAL "")
	endif()
	set(BUILD_TEST_APPLICATION OFF CACHE INTERNAL "")
	FetchContent_MakeAvailable(qt5keychain)
else()
	find_package(Qt5Keychain REQUIRED)
endif()

if (APPLE)
	find_package(Qt5MacExtras REQUIRED)
endif(APPLE)

if (Qt5Widgets_FOUND)
	if (Qt5Widgets_VERSION VERSION_LESS 5.15.0)
		message(STATUS "Qt version ${Qt5Widgets_VERSION}")
		message(WARNING "Minimum supported Qt5 version is 5.15!")
	endif()
endif(Qt5Widgets_FOUND)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
if(NOT MSVC)
	set(
		CMAKE_CXX_FLAGS
		"${CMAKE_CXX_FLAGS} \
		-Wall \
		-Wextra \
		-pedantic \
		-fsized-deallocation \
		-fdiagnostics-color=always \
		-Wunreachable-code \
		-Wno-attributes"
		)
	if (NOT CMAKE_COMPILER_IS_GNUCXX)
		# -Wshadow is buggy and broken in GCC, so do not enable it.
		# see https://gcc.gnu.org/bugzilla/show_bug.cgi?id=79328
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wshadow")
	endif()
endif()

if (MSVC)
	set(
		CMAKE_CXX_FLAGS
		"${CMAKE_CXX_FLAGS} /bigobj"
		)
endif()

if(NOT (CMAKE_BUILD_TYPE OR CMAKE_CONFIGURATION_TYPES))
	set(CMAKE_BUILD_TYPE "Debug" CACHE STRING
		"Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
		FORCE)
	message("Setting build type to '${CMAKE_BUILD_TYPE}'")
else(NOT (CMAKE_BUILD_TYPE OR CMAKE_CONFIGURATION_TYPES))
	message("Build type set to '${CMAKE_BUILD_TYPE}'")
endif(NOT (CMAKE_BUILD_TYPE OR CMAKE_CONFIGURATION_TYPES))

set(SPDLOG_DEBUG_ON false)

# Windows doesn't handle CMAKE_BUILD_TYPE.
if(NOT WIN32)
	if(CMAKE_BUILD_TYPE STREQUAL "Debug")
		set(SPDLOG_DEBUG_ON true)
	else()
		set(SPDLOG_DEBUG_ON false)
	endif()
endif()

find_program(GIT git)
if(GIT)
	execute_process(
		WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
		COMMAND ${GIT} rev-parse --short HEAD
		OUTPUT_VARIABLE GIT_OUT OUTPUT_STRIP_TRAILING_WHITESPACE
		)
	if(GIT_OUT)
		set(CPACK_PACKAGE_VERSION_PATCH "${CPACK_PACKAGE_VERSION_PATCH}-${GIT_OUT}")
	else()
		set(CPACK_PACKAGE_VERSION_PATCH "${CPACK_PACKAGE_VERSION_PATCH}")
	endif()
endif(GIT)

set(CPACK_PACKAGE_VERSION ${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH})
set(PROJECT_VERSION ${CPACK_PACKAGE_VERSION})

message(STATUS "Version: ${PROJECT_VERSION}")

cmake_host_system_information(RESULT BUILD_HOST QUERY HOSTNAME)

include(CheckSymbolExists)
check_symbol_exists(backtrace_symbols_fd "execinfo.h" HAVE_BACKTRACE_SYMBOLS_FD)

configure_file(cmake/nheko.h config/nheko.h)

#
# Declare source and header files.
#
set(SRC_FILES
	# Dialogs
	src/dialogs/FallbackAuth.cpp
	src/dialogs/FallbackAuth.h
	src/dialogs/ReCaptcha.cpp
	src/dialogs/ReCaptcha.h

	# Emoji
	src/emoji/EmojiModel.cpp
	src/emoji/EmojiModel.h
	src/emoji/Provider.cpp
	src/emoji/Provider.h

	# Timeline
	src/timeline/CommunitiesModel.cpp
	src/timeline/CommunitiesModel.h
	src/timeline/DelegateChooser.cpp
	src/timeline/DelegateChooser.h
	src/timeline/EventStore.cpp
	src/timeline/EventStore.h
	src/timeline/InputBar.cpp
	src/timeline/InputBar.h
	src/timeline/Permissions.cpp
	src/timeline/Permissions.h
	src/timeline/PresenceEmitter.cpp
	src/timeline/PresenceEmitter.h
	src/timeline/Reaction.cpp
	src/timeline/Reaction.h
	src/timeline/RoomlistModel.cpp
	src/timeline/RoomlistModel.h
	src/timeline/TimelineFilter.cpp
	src/timeline/TimelineFilter.h
	src/timeline/TimelineModel.cpp
	src/timeline/TimelineModel.h
	src/timeline/TimelineViewManager.cpp
	src/timeline/TimelineViewManager.h

	# UI components
	src/ui/HiddenEvents.cpp
	src/ui/HiddenEvents.h
	src/ui/MxcAnimatedImage.cpp
	src/ui/MxcAnimatedImage.h
	src/ui/MxcMediaProxy.cpp
	src/ui/MxcMediaProxy.h
	src/ui/NhekoCursorShape.cpp
	src/ui/NhekoCursorShape.h
	src/ui/NhekoDropArea.cpp
	src/ui/NhekoDropArea.h
	src/ui/NhekoEventObserver.cpp
	src/ui/NhekoEventObserver.h
	src/ui/NhekoGlobalObject.cpp
	src/ui/NhekoGlobalObject.h
	src/ui/RoomSettings.cpp
	src/ui/RoomSettings.h

=== Makefile ===
FILES=`find lib include tests examples -type f -type f \( -iname "*.cpp" -o -iname "*.hpp" \)`

SYNAPSE_IMAGE="matrixdotorg/synapse:v1.63.1"

DEPS_BUILD_DIR=.deps
DEPS_SOURCE_DIR=deps

help: ## This help message
	@grep -E '^[0-9a-zA-Z_-]+:.*?## .*$$' $(MAKEFILE_LIST) | sort | awk 'BEGIN {FS = ":.*?## "}; {printf "\033[36m%-20s\033[0m %s\n", $$1, $$2}'
	@# Change the digit following by an 's' to adjust the width of the help text

third-party: ## Build & install third party dependencies
	@cmake -GNinja -H${DEPS_SOURCE_DIR} -B${DEPS_BUILD_DIR} -DCMAKE_BUILD_TYPE=Release -DUSE_BUNDLED_BOOST=OFF -DUSE_BUNDLED_JSON=OFF
	@cmake --build ${DEPS_BUILD_DIR}

debug: ## Create a debug build
	@cmake -GNinja -H. -Bbuild \
		-DCMAKE_BUILD_TYPE=Debug \
		-DCMAKE_EXPORT_COMPILE_COMMANDS=1 \
		-DOPENSSL_ROOT_DIR=/usr/local/opt/openssl \
		-DCMAKE_INSTALL_PREFIX=${DEPS_BUILD_DIR}/usr
	@cmake --build build

release: ## Create an optimized build
	@cmake -GNinja -H. -Bbuild \
		-DCMAKE_BUILD_TYPE=Release \
		-DOPENSSL_ROOT_DIR=/usr/local/opt/openssl \
		-DCMAKE_INSTALL_PREFIX=${DEPS_BUILD_DIR}/usr
	@cmake --build build

test: ## Run the tests
	@cd build/ && GTEST_COLOR=1 ctest --verbose

asan: ## Create a debug build using address sanitizers
	@cmake -GNinja -H. -Bbuild \
		-DCMAKE_BUILD_TYPE=Debug \
		-DOPENSSL_ROOT_DIR=/usr/local/opt/openssl \
		-DCMAKE_INSTALL_PREFIX=${DEPS_BUILD_DIR}/usr \
		-DASAN=1
	@cmake --build build

image:
	docker build -t mtxclient-dev .

synapse: ## Start a synapse instance on docker
	@mkdir -p data
	@chmod 0777 data
	@docker run -v `pwd`/data:/data --rm \
		-e SYNAPSE_SERVER_NAME=localhost -e SYNAPSE_REPORT_STATS=no ${SYNAPSE_IMAGE} generate
	@./.ci/adjust-config.sh
	@docker run -d \
		--name synapse \
		-p 443:8008 \
		-p 8448:8008 \
		-p 8008:8008 \
		-v `pwd`/data:/data ${SYNAPSE_IMAGE}
	@echo Waiting for synapse to start...
	@until curl -s -f -k https://localhost:443/_matrix/client/versions; do echo "Checking ..."; sleep 2; done
	@echo Register alice
	@docker exec synapse /bin/sh -c 'register_new_matrix_user --admin -u alice -p secret -c /data/homeserver.yaml https://localhost:8008'
	@echo Register bob
	@docker exec synapse /bin/sh -c 'register_new_matrix_user --admin -u bob -p secret -c /data/homeserver.yaml https://localhost:8008'
	@echo Register carl
	@docker exec synapse /bin/sh -c 'register_new_matrix_user --admin -u carl -p secret -c /data/homeserver.yaml https://localhost:8008'

stop-synapse: ## Stop any running instance of synapse
	@rm -rf ./data/*
	@docker rm -f synapse 2>&1>/dev/null

restart: stop-synapse synapse

lint: ## Run clang-format on the source code
	@clang-format -i ${FILES} && git diff --exit-code

clean: ## Delete the build directory
	rm -rf build

=== meson_options.txt ===
option('examples', type : 'boolean', value : false)
option('tests', type : 'boolean', value : false)

=== debian/changelog ===
nheko (0.11.3+~0.9.2+~1.0.0+~0.3.0-1build4) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 18:06:43 +1100

nheko (0.11.3+~0.9.2+~1.0.0+~0.3.0-1build3) noble; urgency=medium

  * No-change rebuild against libcurl4t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 16 Mar 2024 06:47:42 +0000

nheko (0.11.3+~0.9.2+~1.0.0+~0.3.0-1build2) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 06:03:37 +0000

nheko (0.11.3+~0.9.2+~1.0.0+~0.3.0-1build1) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 04 Mar 2024 20:09:18 +0000

nheko (0.11.3+~0.9.2+~1.0.0+~0.3.0-1) unstable; urgency=medium

  * add myself as uploader
  * tighten buildflags
  * stop explicitly enable verbose build,
    to support DEB_BUILD_OPTIONS=terse
  * explicitly set buildsystem=cmake and use upstream install,
    concretely including SVG icon and zsh shell completion script
  * add patch 2003
    to avoid forcing ANSI colors in build logs
  * update copyright info:
    + use shortname Expat
    + use shortname Unlicense
    + update coverage
    + use License-Grant field
    + use Reference field
    + list License sections last, sorted alphabetically
    + list upstream right-truncated Files sections first
    + add Upstream-Contact field
    + add secondary source URIs
  * recommend (not depend on) gnome-keyring or kwalletmanager;
    add README.Debian notice
    about how to to disable use of secure secrets service;
    closes: bug#1016149,
    thanks to xiao sheng wen(肖盛文) and Hubert Chathi
  * update git-buildpackage config:
    + enable pristine-tar
    + enable signed tags
    + filter-out any .git* file
    + use DEP14 branches
    + add usage config
  * update watch file:
    + use substitution strings
    + set dversionmangle=auto
    + add usage config
    + track git commits (not release tags)
  * update watch file
    to track secondary tarballs a.k.a. embedded components;
    drop custom make target make-orig-source;
    closes: bug#926668, thanks to Linda Lapinlampi
  * add source helper script copyright-check
  * recommend gstreamer1.0-plugins-bad;
    closes: bug#1037156, thanks to Helmut Grohne

 -- Jonas Smedegaard <dr@jones.dk>  Thu, 29 Feb 2024 16:19:13 +0100

=== debian/control ===
Source: nheko
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Matrix Packaging Team <pkg-matrix-maintainers@alioth-lists.debian.net>
Uploaders:
 Hubert Chathi <uhoreg@debian.org>,
 Jonas Smedegaard <dr@jones.dk>,
Section: net
Priority: optional
Build-Depends:
 asciidoc-base,
 cmake (>= 3.15),
 debhelper-compat (=13),
 dh-exec,
 libcmark-dev (>= 0.29),
 libcpp-httplib-dev,
 libcurl4-openssl-dev,
 libevent-dev,
 libfmt-dev,
 libgstreamer-plugins-bad1.0-dev (>= 1.18.0),
 libgstreamer-plugins-base1.0-dev (>= 1.18.0),
 libgstreamer1.0-dev (>= 1.18.0),
 liblmdb-dev,
 libnice-dev,
 libolm-dev (>= 3.2.7~),
 libqt5svg5-dev,
 libre2-dev,
 libsodium-dev,
 libspdlog-dev,
 libssl-dev,
 libxcb-ewmh-dev,
 nlohmann-json3-dev (>= 3.7.0-2~),
 qt5keychain-dev,
 qtbase5-dev,
 qtdeclarative5-dev,
 qtmultimedia5-dev,
 qtquickcontrols2-5-dev,
 qttools5-dev,
 zlib1g-dev,
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/matrix-team/nheko
Vcs-Git: https://salsa.debian.org/matrix-team/nheko.git
Homepage: https://github.com/Nheko-Reborn/nheko
Rules-Requires-Root: no

Package: nheko
Architecture: any
Depends:
 gstreamer1.0-nice,
 gstreamer1.0-qt5,
 libqt5multimedia5-plugins,
 qml-module-qt-labs-animation,
 qml-module-qt-labs-platform,
 qml-module-qt-labs-settings,
 qml-module-qtgraphicaleffects,
 qml-module-qtmultimedia,
 qml-module-qtquick-controls2,
 qml-module-qtquick-layouts,
 qml-module-qtquick-particles2,
 qml-module-qtquick-window2,
 qml-module-qtquick2,
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 ca-certificates,
 fonts-noto-color-emoji,
 gnome-keyring | kwalletmanager,
 gstreamer1.0-plugins-bad,
 kimageformat-plugins,
 qt5-image-formats-plugins,
Suggests:
 gstreamer1.0-vaapi,
Description: desktop IM client for the Matrix protocol
 Nheko is a Qt-based chat client for Matrix, an open, federated communications
 protocol.  The motivation behind the project is to provide a native desktop
 app for Matrix that feels more like a mainstream chat app and less like an IRC
 client.

=== debian/rules ===
#!/usr/bin/make -f

export QT_SELECT=5

# Lower memory requirements on architectures with only 2 GB address space
ifneq (,$(filter $(DEB_HOST_ARCH),mips mipsel sh4 hppa))
DEB_CFLAGS_MAINT_STRIP = -g1
DEB_CXXFLAGS_MAINT_STRIP = -g1
DEB_CFLAGS_MAINT_APPEND = -g0
DEB_CXXFLAGS_MAINT_APPEND = -g0
DEB_CPPFLAGS_MAINT_APPEND = --param ggc-min-expand=10
ifeq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
DEB_CFLAGS_MAINT_STRIP += -O2
DEB_CXXFLAGS_MAINT_STRIP += -O2
DEB_CFLAGS_MAINT_APPEND += -Os
DEB_CXXFLAGS_MAINT_APPEND += -Os
endif
endif

%:
	dh $@ --buildsystem=cmake --builddirectory=build

# all done in build: build of earlier parts needed to configure later parts
override_dh_auto_configure:

override_dh_auto_build:
	dh_auto_configure --sourcedirectory=coeurl --builddirectory=.deps/coeurl
	dh_auto_build --sourcedirectory=coeurl --builddirectory=.deps/coeurl
	dh_auto_configure --sourcedirectory=mtxclient --builddirectory=.deps/mtxclient -- -DBUILD_LIB_TESTS=OFF -DBUILD_SHARED_LIBS=OFF -DBUILD_LIB_EXAMPLES=OFF -Dcoeurl_DIR=$(CURDIR)/.deps/coeurl
	dh_auto_build --sourcedirectory=mtxclient --builddirectory=.deps/mtxclient
	dh_auto_configure -- -DCMAKE_BUILD_TYPE=RelWithDebInfo -DBUILD_LIB_EXAMPLES=OFF -DUSE_BUNDLED_CPPHTTPLIB=OFF -DLMDBXX_INCLUDE_DIR=$(CURDIR)/lmdbxx -Dcoeurl_DIR=$(CURDIR)/.deps/coeurl -DMatrixClient_DIR=$(CURDIR)/.deps/mtxclient
	dh_auto_build

override_dh_auto_test:
	dh_auto_test --sourcedirectory=coeurl --builddirectory=.deps/coeurl
	dh_auto_test --sourcedirectory=mtxclient --builddirectory=.deps/mtxclient
	dh_auto_test

=== debian/watch ===
version=4
# check: uscan --report
# update: gbp import-orig --upstream-vcs-tag=vX.Y.Z --uscan

opts=\
filenamemangle=s/.*?(@ANY_VERSION@@ARCHIVE_EXT@)/@PACKAGE@-$1/,\
dversionmangle=auto \
https://github.com/Nheko-reborn/nheko/tags \
.*?@ANY_VERSION@@ARCHIVE_EXT@ group

opts=\
component=mtxclient,\
filenamemangle=s/.*?(@ANY_VERSION@@ARCHIVE_EXT@)/@PACKAGE@-mtxclient-$1/,\
dversionmangle=auto \
https://github.com/Nheko-Reborn/mtxclient/tags \
.*?v(0\.9\.2)@ARCHIVE_EXT@ group

opts=\
component=lmdbxx,\
filenamemangle=s/.*?(@ANY_VERSION@@ARCHIVE_EXT@)/@PACKAGE@-lmdbxx-$1/,\
dversionmangle=auto \
https://github.com/Nheko-Reborn/lmdbxx/tags \
.*?(1\.0\.0)@ARCHIVE_EXT@ group

opts=\
component=coeurl,\
filenamemangle=s/.*?(@ANY_VERSION@@ARCHIVE_EXT@)/@PACKAGE@-coeurl-$1/,\
dversionmangle=auto \
https://nheko.im/nheko-reborn/coeurl/-/tags \
.*?v(0\.3\.0)@ARCHIVE_EXT@ group
